Subject: Re: [RFC PATCH 01/21] Documentation: add comparison of build systems

From: Patrick Steinhardt <[email-masked]>
Date: Mon, 7 Oct 2024 12:17:51 +0200

On Wed, Oct 02, 2024 at 04:24:10PM -0400, Eric Sunshine wrote:
> On Wed, Oct 2, 2024 at 11:16 AM Patrick Steinhardt <[email-masked]> wrote:
> > We're contemplating whether to eventually replace our build systems with
> > a build system that is easier to use. Add a comparison of build systems
> > to our technical documentation as a baseline for discussion.
> >
> > Signed-off-by: Patrick Steinhardt <[email-masked]>
> > ---
> > +=== Rust support
> > +
> > +Many long-time Git contributors are nowadays in favor of adopting Rust as a
> > +second language next to C. The build system SHOULD thus support Rust such that
> > +we do not have to reopen the discussion once we decide to pick up Rust.
> 
> I've been watching the Rust discussion mostly from the sidelines, so
> it's possible that I've missed something, but I was more than a little
> surprised to see the claim that "Many long-time Git contributors [are]
> in favor of adopting Rust" since my impression of the discussions does
> not reflect that claim, nor could I find sufficient references to
> support such a strong statement. My understanding of the situation is
> rather different; I've seen both proponents and opponents. With
> regards to project regulars...

I felt that during the Git Contributor's summit the room was in favor of
adopting Rust in general. The discussion seemed to rather revolve around
_how_ we start to adopt it, not _if_ we do so. I also cannot really
remember anybody pushing back on adopting Rust.

In any case, I'm happy to tone this down a bit, as the document is not
here to make the case for Rust. I think that it is very likely that we
will eventually start to adopt Rust, and because of that I tend to think
that we should be prepared for such a future instead of having to
reevaluate our build system because it cannot handle such a potential
future.

[snip]
> * At least one well-established contributor has stated[4] that "Rust
> scares" him. (Possibly this was said somewhat in jest, but I suspect
> the feeling may be shared by more than a few long-time Git
> contributors who see Rust as an overly complex, complicated, and
> convoluted language but who haven't spoken up because they understand
> that the programming world in general is moving toward more modern
> languages such as Rust and Go.)

Well, that was me :) I _am_ scared of the learning curve of Rust, but I
also think that it puts enough on the table to be a worthwhile addition.
So it was said half-jokingly.

Patrick